var orgimg="";

//閉じ警告
//window.onbeforeunload = function(){return '';};

document.addEventListener('DOMContentLoaded', function(){
  //ページスタンバイ
  chrome.runtime.sendMessage({mode:"canvasok"});
  //キャプチャ読込み
  chrome.runtime.onMessage.addListener(function(request, sender, sendResponse){
    if(request.img){
      if(request.err){
        orgimg=request.img;
        document.getElementById("newimg").innerHTML = "座標が取得できませんでした。ページの表示部分全体のスクショを表示しています<br><a href=\""+orgimg+"\" download=\""+fname()+"\">画像を保存</a><br><img src=\""+orgimg+"\" id=\"nowimg\" style=\"max-height:580px;max-width:1030px;\">";
      }else{
        var img = new Image();
        img.src = request.img;
        img.onload = function(){
          var canvas = document.getElementById('sukusyo');
          var ctx = canvas.getContext('2d');
          canvas.width = 1136;
          canvas.height = 660;
          //レティナ対応
          var ratio = window.devicePixelRatio;
          if(ratio>1){
            var ratx = Math.round(request.sx*ratio); var raty = Math.round(request.sy*ratio);
            var ratwid = Math.round(img.width*ratio); var rathei = Math.round(img.height*ratio);
            img = ctx.drawImage(img,ratx,raty,ratwid,rathei,0,0,img.width,img.height);
            document.getElementById("edithead").innerHTML = '※撮影はページがスクロールしていない状態で行って下さい。<b style="color:#ff0000">画面表示倍率が100%以外の場合は座標ズレや画質の劣化が起こります。『現在の倍率：'+parseInt(ratio*100)+'%』</b>';
          }else{
            ctx.drawImage(img, request.sx, request.sy, 1136, 660,0,0,1136,660);
          }
          orgimg=canvas.toDataURL('image/png');
          /*var cutimg = new Image();
          cutimg.src = orgimg;
          cutimg.onload = function(){
            var canvas = document.getElementById('sukusyo');
            var ctx2 = canvas.getContext('2d');
            canvas.width = 1030;
            canvas.height = 580;
            ctx2.drawImage(cutimg, 0, 0, 1030, 580,0,0,1030,580);
            Ccutimg = canvas.toDataURL('image/png');
            document.getElementById("newimg").innerHTML = "<img src=\""+Ccutimg+"\" id=\"nowimg\">コピーライト部は『編集をリセット』で表示できます";
            document.getElementById("savelink").innerHTML = "<a href=\""+Ccutimg+"\" download=\""+fname()+"\">画像を保存</a> (1030x580px)";
          };*/
          document.getElementById("newimg").innerHTML = "<img src=\""+orgimg+"\" id=\"nowimg\">";
          document.getElementById("savelink").innerHTML = "<a href=\""+orgimg+"\" download=\""+fname()+"\">画像を保存</a> (1136x660px)";
        };
      }
    }
  });  
});

//審神者名マスク
document.getElementById("namemask").addEventListener("click", function (){
  var msk = "maname";
  var radioList = document.getElementsByName("mask");
  for(var i=0; i<3; i++){
    if (radioList[i].checked){msk = radioList[i].value +"name"; break;}
  }
  radioList = null;
  hensyu(msk);trimreset();return null;
}, false);

//Lvマスク
document.getElementById("lvmask").addEventListener("click", function(){
  var msk = "malv";
  var radioList = document.getElementsByName("mask");
  for(var i=0; i<3; i++){
    if (radioList[i].checked){msk = radioList[i].value +"lv"; break;}
  }
  radioList = null;
  hensyu(msk);trimreset();return null;
}, false);

//80%
document.getElementById("syukusyo").addEventListener("click", function (){hensyu("syuku");trimreset();return null;}, false);
//コピーライトカット
document.getElementById("copycut").addEventListener("click", function (){hensyu("ccut");trimreset();return null;}, false);
//周囲トリミング
document.getElementById("wakucut").addEventListener("click", function (){hensyu("wcut");trimreset();return null;}, false);
//JPG
document.getElementById("tojpg").addEventListener("click", function (){hensyu("jpg");trimreset();return null;}, false);


//リセット
document.getElementById("resetimg").addEventListener("click", function (){
  document.getElementById("newimg").innerHTML = "<img src=\""+orgimg+"\" id=\"nowimg\">";
  document.getElementById("savelink").innerHTML = "<a href=\""+orgimg+"\" download=\""+fname()+"\">画像を保存</a>"+imgjyoho();
  trimreset();return null;
});

function hensyu(swi){
  //console.log(swi);
  var img = document.getElementById('nowimg');
  var canvas = document.getElementById('sukusyo');
  var ctx = canvas.getContext('2d');
  var xstart=0;var ystart=0;var canwid=img.width; var canhei=img.height;
  
  //縮小・カット
  switch(swi){
    case "ccut": //copyカット
      canwid = 1136; canhei = 640;
      break;
    case "wcut": //枠カット
      xstart=80; ystart=76; canwid = 946; canhei = 504;
      break;
    case "ncut": //任意カット
      var siteix=document.getElementById("sitenx").value;
      var siteiy=document.getElementById("siteny").value;
      var haba=document.getElementById("haba").value;
      var takasa=document.getElementById("takasa").value;
      if(Number(siteix)){xstart=siteix;}if(Number(siteiy)){ystart=siteiy;}
      if(Number(haba)){canwid=haba;}if(Number(takasa)){canhei=takasa;}
      break;
    case "syuku": //縮小
      canwid = Math.floor(img.width*0.8); canhei = Math.floor(img.height*0.8);
      break;
  }

  canvas.width = canwid; canvas.height = canhei;
  if(swi=="wcut" || swi=="ccut" || swi=="ncut"){ctx.drawImage(img, xstart, ystart, canwid, canhei,0,0,canwid,canhei);}
  else if(swi=="syuku"){ctx.drawImage(img,0,0,img.width,img.height,0,0,canwid,canhei);}
  else{ctx.drawImage(img,0,0);}
  
  //マスク
  switch(swi){
    case "maname": //本丸名
      ctx.fillStyle = 'rgb(245, 245, 245)'; 
      ctx.fillRect(142, 5, 150, 25);
      break;
    case "malv": //本丸Lv
      ctx.fillStyle = 'rgb(50, 50, 50)'; 
      ctx.fillRect(100, 16, 33, 20);
      break;
    case "sename": //戦績名
      ctx.fillStyle = 'rgb(237, 220, 188)'; 
      ctx.fillRect(208, 126, 715, 29);
      break;
    case "selv": //戦績Lv
      ctx.fillStyle = 'rgb(237, 220, 188)'; 
      ctx.fillRect(192, 158, 42, 25);
      break;
    case "btname": //戦後名
      ctx.fillStyle = 'rgb(70, 80, 150)'; 
      ctx.fillRect(103, 3, 230, 25);//16, 46, 220, 25
      break; 
    case "btlv": //戦後Lv
      ctx.fillStyle = 'rgb(50, 50, 50)'; 
      ctx.fillRect(47, 3, 38, 25);//52, 77, 50, 25
      break;
  }
  
  //保存形式
  var editimg ="";
  if(swi=="jpg"){editimg = canvas.toDataURL('image/jpeg',0.7);}
  else{editimg = canvas.toDataURL('image/png');}

  var eimg = new Image();
  eimg.src = editimg;
  eimg.onload = function(){
    document.getElementById("newimg").innerHTML = "<img src=\""+eimg.src+"\" id=\"nowimg\">";
    document.getElementById("savelink").innerHTML = "<a href=\""+editimg+"\" download=\""+fname()+"\">画像を保存</a>"+imgjyoho();
  };
  return null;
}

//ファイル名
function fname(){
  var date = new Date();
  var mm = tdouble(date.getMonth() + 1);
  var dd = tdouble(date.getDate());
  var hh = tdouble(date.getHours());
  var mi = tdouble(date.getMinutes());
  var se = tdouble(date.getSeconds());
  return "tourabu"+date.getFullYear()+mm+dd+hh+mi+se;
}
function tdouble(num){
  num += "";
  if(num.length === 1){num = "0" + num;}
  return num;
}

//画像情報
function imgjyoho(){
  var nimg=document.getElementById('nowimg');
  return " ("+nimg.width+"x"+nimg.height+"px)";
}

//任意トリミング
document.getElementById("siteicut").addEventListener("change", function(){
  if(document.getElementById("siteicut").checked){
    document.addEventListener('click', onClick, false);
    document.getElementById("capmes").innerText="クリックで始点(左上)を設定";
    document.getElementById("ninicut").style.display="block";
  }
  else{
    trimreset();
  }
}, false);
function onClick(e){
  var trimline = document.getElementById('trimline');
  var capmes = document.getElementById("capmes");
  var sitenx = document.getElementById("sitenx");
  var siteny = document.getElementById("siteny");
  var rect = document.getElementById('nowimg').getBoundingClientRect();//rect.left,rect.top,rect.width,rect.height
  var mX =  Math.round(e.clientX - rect.left);
  var mY =  Math.round(e.clientY - rect.top);
  
  if(mX>0 && mY>0 && mX<rect.width && mY<rect.height){ //画像範囲判定
    if(Number(document.getElementById("haba").value ) > 0 ){
      capmes.innerText="ボタンでカット実行、画像外をクリックでリセット";
      return null;
    }
    //始点
    if(sitenx.value === ""){
      trimline.style.display="block";
      trimline.style.top=(e.clientY+window.pageYOffset)+"px";
      trimline.style.left=(e.clientX+window.pageXOffset)+"px";
      sitenx.value = mX;
      siteny.value = mY;
      capmes.innerText="終点(左下)をクリック、画像外クリックでリセット";
    }
    //終点
    if(Number(sitenx.value) > 0){
      var mW = mX-sitenx.value;
      var mH = mY-siteny.value;
      if(mW>0 && mH>0){
        trimline.style.width=mW+"px";
        trimline.style.height=mH+"px";
        document.getElementById("haba").value = mW;
        document.getElementById("takasa").value = mH;
        capmes.innerText="画像外をクリックでリセット";
        document.getElementById("cutEnt").style.display="block";
      }
    }
  }
  else{
    capmes.innerText="クリックで始点(左上)を設定";
    sitenx.value = "";
    siteny.value = "";
    document.getElementById("haba").value = "";
    document.getElementById("takasa").value = "";
    trimline.style.display="none";
    document.getElementById("cutEnt").style.display="none";
    trimline.style.width="0px";
    trimline.style.height="0px";
  }
}

document.getElementById("cutEnt").addEventListener("click", function (){
  hensyu("ncut");
  trimreset();
  return null;
}, false);

function trimreset(){
  document.getElementById("sitenx").value = "";
  document.getElementById("siteny").value = "";
  document.getElementById("haba").value = "";
  document.getElementById("takasa").value = "";
  
  document.getElementById("cutEnt").style.display="none";
  document.getElementById("trimline").style.display="none";
  document.getElementById("trimline").style.width="0px";
  document.getElementById("trimline").style.height="0px";
  
  document.removeEventListener('click', onClick, false);
  document.getElementById("siteicut").checked=false;
  document.getElementById("capmes").innerText="チェックボックスONで範囲指定開始";
  document.getElementById("ninicut").style.display="none";
}

document.getElementById("mask_ma").addEventListener("click", function(){
  document.getElementById("maskbtn").style.backgroundColor = '#709772';
});
document.getElementById("mask_se").addEventListener("click", function(){
  document.getElementById("maskbtn").style.backgroundColor = '#906fa9';
});
document.getElementById("mask_bt").addEventListener("click", function(){
  document.getElementById("maskbtn").style.backgroundColor = '#c1758a';
});
/*
  var xhr = new XMLHttpRequest();
  xhr.onreadystatechange = function(){
    if(xhr.readyState == 4){
      var content = xhr.getResponseHeader('Content-Type');
      console.log("Content: " + content);
    }
  };
  xhr.open("GET" ,nimg.src);
  xhr.send(null);// XHR通信開始
*/